#include "stdafx.h"

#include "../BasicCompiler_Common/DebugSection.h"

#ifdef _AMD64_
#include "../compiler_x64/opcode.h"
#else
#include "../compiler_x86/opcode.h"
#endif

#define MDLFILE_VER	0x70000003

using namespace ActiveBasic::Compiler;


void SetLpIndex_DebugFile(char *buffer,int *p,const Type &type){
	if(NATURAL_TYPE(type.GetBasicType())==DEF_OBJECT || NATURAL_TYPE(type.GetBasicType())==DEF_STRUCT){
		lstrcpy(buffer+(*p),type.GetClass().GetName().c_str());
		(*p)+=lstrlen(buffer+(*p))+1;
	}
	else{
		*(LONG_PTR *)(buffer+(*p))=type.GetIndex();
		(*p)+=sizeof(LONG_PTR);
	}
}


void GetLpIndex_DebugFile(char *buffer,int *p,Type &type){
	if(NATURAL_TYPE(type.GetBasicType())==DEF_OBJECT || NATURAL_TYPE(type.GetBasicType())==DEF_STRUCT){
		char szClassName[VN_SIZE];
		lstrcpy(szClassName,buffer+(*p));
		(*p)+=lstrlen(buffer+(*p))+1;

		type.SetClassPtr(
			compiler.GetObjectModule().meta.GetClasses().FindEx( LexicalAnalyzer::FullNameToSymbol( szClassName ) )
		);
	}
	else{
		type.SetIndex( *(LONG_PTR *)(buffer+(*p)) );
		(*p)+=sizeof(LONG_PTR);
	}
}



CDebugSection::~CDebugSection(){
	if(dwImageBase) DeleteDebugInfo();
	if(buffer){
		HeapDefaultFree(buffer);
		buffer=0;
	}
}
void CDebugSection::make(void){
	int i2,BufferSize;

	if(buffer){
		HeapDefaultFree(buffer);
		buffer=0;
	}

	i2=0;

	extern char *basbuf;
	BufferSize=lstrlen(basbuf)+65535;
	buffer=(char *)HeapAlloc(hHeap,0,BufferSize);

	//fobOpt@C̃o[W
	*(long *)(buffer+i2)=MDLFILE_VER;
	i2+=sizeof(long);

	//vbgtH[̃rbg
	*(long *)(buffer+i2)=PLATFORM;
	i2+=sizeof(long);


	// IuWFNgW[
	{
		// eLXgf[^ɃVACY
		std::string textString;
		compiler.GetObjectModule().WriteString( textString );

		// TCY
		*(long *)(buffer+i2) = (long)textString.size();
		i2+=sizeof(long);

		//obt@Ȃꍇ͍Ċm
		if(BufferSize<i2+(int)textString.size()+32768){
			while( BufferSize<i2+(int)textString.size()+32768 )
			{
				BufferSize+=32768;
			}

			buffer=(char *)HeapReAlloc(hHeap,0,buffer,BufferSize);
		}

		// obt@
		memcpy( buffer+i2, textString.c_str(), textString.size() );
		i2 += (int)textString.size();
	}

	// IuWFNgW[Xgɗގ\[XR[hXg
	{
		// IuWFNgW[Xgɗގ\[XR[hXg쐬
		BasicSources sources;
		BOOST_FOREACH( const ObjectModule *pObjectModule, compiler.staticLibraries )
		{
			sources.push_back( pObjectModule->GetSource() );
		}

		// eLXgf[^ɃVACY
		std::string textString;
		sources.WriteBinaryString( textString );

		// TCY
		*(long *)(buffer+i2) = (long)textString.size();
		i2+=sizeof(long);

		//obt@Ȃꍇ͍Ċm
		if(BufferSize<i2+(int)textString.size()+32768){
			while( BufferSize<i2+(int)textString.size()+32768 )
			{
				BufferSize+=32768;
			}

			buffer=(char *)HeapReAlloc(hHeap,0,buffer,BufferSize);
		}

		// obt@
		memcpy( buffer+i2, textString.c_str(), textString.size() );
		i2 += (int)textString.size();
	}


	////////////////////////
	// R[hƍsԍ̊֌W
	////////////////////////
	extern SourceLines oldSourceLines;

	*(long *)(buffer+i2)=(long)oldSourceLines.size();
	i2+=sizeof(long);
	BOOST_FOREACH( const SourceLine &sourceLine, oldSourceLines )
	{
		*(long *)(buffer+i2) = sourceLine.GetNativeCodePos();
		i2+=sizeof(long);

		*(long *)(buffer+i2) = sourceLine.GetCodeType();
		i2+=sizeof(long);

		*(long *)(buffer+i2) = sourceLine.GetSourceCodePosition().GetRelationalObjectModuleIndex();
		i2+=sizeof(long);

		*(long *)(buffer+i2) = sourceLine.GetSourceCodePosition().GetPos();
		i2+=sizeof(long);

		//obt@Ȃꍇ͍Ċm
		if(BufferSize<i2+32768){
			BufferSize+=32768;
			buffer=(char *)HeapReAlloc(hHeap,0,buffer,BufferSize);
		}
	}

	//O[os̈̃TCY
	extern int GlobalOpBufferSize;
	*(long *)(buffer+i2)=GlobalOpBufferSize;
	i2+=sizeof(long);

	length=i2;
}

char *CDebugSection::MakeSingleStepCode(void){
	char *buffer;
	buffer=(char *)HeapAlloc(hHeap,0,SizeOf_CodeSection);

	memcpy(buffer,OpBuffer,SizeOf_CodeSection);

	BOOST_FOREACH( const SourceLine &sourceLine, _oldSourceLines )
	{
		if(!(
			sourceLine.IsInSystemProc()
			|| sourceLine.IsInDebugProc() ) )
		{
			//int 3
			buffer[sourceLine.GetNativeCodePos()]=(char)0xCC;
		}
	}

	return buffer;
}
BOOL CDebugSection::__load(void){
	int i2,i3;

	compiler.ClearCompilingUserProcAndClass();

	i2=0;

	//fobOpt@C̃o[W`FbN
	if(*(long *)(buffer+i2)<MDLFILE_VER){
		HeapDefaultFree(buffer);
		return 0;
	}
	i2+=sizeof(long);

	//vbgtH[̃rbg`FbN
	if(*(long *)(buffer+i2)!=PLATFORM){
		HeapDefaultFree(buffer);
		return 0;
	}
	i2+=sizeof(long);

	// IuWFNgW[
	{
		// TCY
		int size = *(long *)(buffer+i2);
		i2 += sizeof(long);

		// obt@
		const std::string textString( (const char *)(buffer + i2), size );
		i2 += size;

		// eLXgf[^VACY
		this->objectModule.ReadString( textString );

		compiler.SelectObjectModule( &this->objectModule );
	}

	// IuWFNgW[Xgɗގ\[XR[hXg
	{
		// TCY
		int size = *(long *)(buffer+i2);
		i2 += sizeof(long);

		// obt@
		const std::string textString( (const char *)(buffer + i2), size );
		i2 += size;

		// eLXgf[^VACY
		this->_sourcesLinkRelationalObjectModule.ReadBinaryString( textString );
	}

	//R[hƍsԍ̊֌W
	int maxLineInfoNum = *(long *)(buffer+i2);
	i2+=sizeof(long);
	for(i3=0;i3<maxLineInfoNum;i3++){
		int nativeCodePos = *(long *)(buffer+i2);
		i2+=sizeof(long);

		DWORD sourceLineType = *(DWORD *)(buffer+i2);
		i2+=sizeof(long);

		int relationalObjectModuleIndex = *(long *)(buffer+i2);
		i2+=sizeof(long);

		int sourceCodePos = *(long *)(buffer+i2);
		i2+=sizeof(long);

		_oldSourceLines.push_back(
			SourceLine(
				nativeCodePos,
				sourceLineType,
				SourceCodePosition( relationalObjectModuleIndex, sourceCodePos )
			)
		);
	}

	//O[os̈̃TCY
	GlobalOpBufferSize=*(long *)(buffer+i2);
	i2+=sizeof(long);


	HeapDefaultFree(buffer);
	buffer=0;


	this->pSub_DebugSys_EndProc=GetSubHash("_DebugSys_EndProc");
	if( this->pSub_DebugSys_EndProc == NULL )
	{
		MessageBox( 0, "_DebugSys_EndProcȂ", "ActiveBasic", MB_OK );
	}


	SingleStepCodeBuffer=MakeSingleStepCode();
	
	//\[XR[h
	extern char *basbuf;
	basbuf = const_cast<char *>(compiler.GetObjectModule().GetSource().GetBuffer());


	/////////////////////////////
	// u[N|CgKp
	/////////////////////////////

	// IuWFNgW[Xgɗގ\[XR[hXg
	extern BasicSources sourcesLinkRelationalObjectModule;
	sourcesLinkRelationalObjectModule = this->_sourcesLinkRelationalObjectModule;

	//R[hƍsԍ̊֌W
	extern SourceLines oldSourceLines;
	oldSourceLines = this->_oldSourceLines;

	BreakStepCodeBuffer=pobj_DBBreakPoint->update(OpBuffer,SizeOf_CodeSection);

	//vZXɃRs[
	extern HANDLE hDebugProcess;
	SIZE_T accessBytes;
	WriteProcessMemory(hDebugProcess,(void *)(ULONG_PTR)(dwImageBase+dwRVA_CodeSection),
		BreakStepCodeBuffer,
		SizeOf_CodeSection,&accessBytes);


	return 1;
}

BOOL CDebugSection::load(HMODULE hModule){
	if(buffer){
		HeapDefaultFree(buffer);
		buffer=0;
	}


	extern HANDLE hDebugProcess;
	SIZE_T accessBytes;
	IMAGE_DOS_HEADER ImageDosHeader;
	ReadProcessMemory(hDebugProcess,hModule,&ImageDosHeader,sizeof(IMAGE_DOS_HEADER),&accessBytes);

	int pe_size;
#ifdef _AMD64_
	IMAGE_NT_HEADERS64 pe_hdr;
	pe_size=sizeof(IMAGE_NT_HEADERS64);
#else
	IMAGE_NT_HEADERS pe_hdr;
	pe_size=sizeof(IMAGE_NT_HEADERS);
#endif
	ReadProcessMemory(hDebugProcess,(void *)(((ULONG_PTR)hModule)+ImageDosHeader.e_lfanew),&pe_hdr,pe_size,&accessBytes);

	IMAGE_SECTION_HEADER *pSectionHdr;
	pSectionHdr=(IMAGE_SECTION_HEADER *)HeapAlloc(hHeap,0,pe_hdr.FileHeader.NumberOfSections*sizeof(IMAGE_SECTION_HEADER));
	ReadProcessMemory(hDebugProcess,
		(void *)(((ULONG_PTR)hModule)+ImageDosHeader.e_lfanew+pe_size),
		pSectionHdr,
		pe_hdr.FileHeader.NumberOfSections*sizeof(IMAGE_SECTION_HEADER),
		&accessBytes);

	int i;
	for(i=0;i<pe_hdr.FileHeader.NumberOfSections;i++){

		//C^uZNV̏
		if(lstrcmp((char *)pSectionHdr[i].Name,".data")==0){
			dwRVA_RWSection=pSectionHdr[i].VirtualAddress;
		}

		//R[hZNV̏
		if(lstrcmp((char *)pSectionHdr[i].Name,".text")==0){
			dwRVA_CodeSection=pSectionHdr[i].VirtualAddress;
			SizeOf_CodeSection=pSectionHdr[i].SizeOfRawData;
		}

		//fobOZNV̏
		if(lstrcmp((char *)pSectionHdr[i].Name,".debug")==0){
			length=pSectionHdr[i].Misc.VirtualSize;
			buffer=(char *)HeapAlloc(hHeap,0,length+1);

			ReadProcessMemory(hDebugProcess,
				(void *)(((ULONG_PTR)hModule)+pSectionHdr[i].VirtualAddress),
				buffer,
				length,
				&accessBytes);
			buffer[length]=0;
		}

	}
	HeapDefaultFree(pSectionHdr);

	if(!buffer) return 0;


	dwImageBase=(DWORD)(ULONG_PTR)hModule;



	if(OpBuffer) free(OpBuffer);
	OpBuffer=(char *)malloc(SizeOf_CodeSection);

	ReadProcessMemory(hDebugProcess,
		(void *)(ULONG_PTR)(dwImageBase+dwRVA_CodeSection),OpBuffer,
		SizeOf_CodeSection,&accessBytes);


	return __load();
}

void CDebugSection::choice(void){
	//C[Wx[X
	extern DWORD ImageBase;
	ImageBase=this->dwImageBase;

	//C^uZNVRVA
	extern int MemPos_RWSection;
	MemPos_RWSection=this->dwRVA_RWSection;

	//R[hZNVRVAƃTCY
	extern int MemPos_CodeSection;
	extern int FileSize_CodeSection;
	MemPos_CodeSection=this->dwRVA_CodeSection;
	FileSize_CodeSection=this->SizeOf_CodeSection;

	// IuWFNgW[
	compiler.SelectObjectModule( &this->objectModule );

	//R[hƍsԍ̊֌W
	extern SourceLines oldSourceLines;
	oldSourceLines = this->_oldSourceLines;

	//O[os̈̃TCY
	extern int GlobalOpBufferSize;
	GlobalOpBufferSize=this->GlobalOpBufferSize;

	extern const UserProc *pSub_DebugSys_EndProc;
	pSub_DebugSys_EndProc=this->pSub_DebugSys_EndProc;

	//lCeBuR[hobt@
	extern char *OpBuffer;
	OpBuffer=this->OpBuffer;
}

void CDebugSection::DeleteDebugInfo(void){
	//R[hobt@
	free(OpBuffer);
	OpBuffer=0;

	HeapDefaultFree(SingleStepCodeBuffer);
	SingleStepCodeBuffer=0;

	HeapDefaultFree(BreakStepCodeBuffer);
	BreakStepCodeBuffer=0;
}



CDBDebugSection::CDBDebugSection()
{
}
CDBDebugSection::~CDBDebugSection()
{
	BOOST_FOREACH( CDebugSection *pDebugSection, debugSections )
	{
		delete pDebugSection;
	}
	debugSections.clear();
}

BOOL CDBDebugSection::add(HMODULE hModule){
	CDebugSection *pobj_d;
	pobj_d=new CDebugSection();
	if(!pobj_d->load(hModule)){
		//fobO񂪑݂ȂƂ
		delete pobj_d;
		return 0;
	}

	debugSections.push_back( pobj_d );

	return 1;
}

void CDBDebugSection::del(HMODULE hModule){
	for( int i=0; i<static_cast<int>(this->debugSections.size()); i++ )
	{
		if( (HMODULE)(ULONG_PTR)this->debugSections[i]->dwImageBase == hModule )
		{
			delete debugSections[i];
			Jenga::Common::EraseVectorItem<std::vector<CDebugSection *>>( debugSections, i );
			break;
		}
	}
}

void CDBDebugSection::choice( int index )
{
	pobj_now = debugSections[index];
	pobj_now->choice();
}



CDBDebugSection *pobj_DBDebugSection;
